﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.Xml;
using GridAndRepeater.NwindDataSetTableAdapters;
using Telerik.WinControls;
using Telerik.WinControls.UI;

namespace GridAndRepeater
{
    public partial class Form1 : Form, INestedGridElementDataSourceProvider
    {
        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'nwindDataSet.Orders' table. You can move, or remove it, as needed.
            this.ordersTableAdapter.Fill(this.nwindDataSet.Orders);
            // TODO: This line of code loads data into the 'nwindDataSet.Customers' table. You can move, or remove it, as needed.
            this.customersTableAdapter.Fill(this.nwindDataSet.Customers);

            //Create column bound to the ID for nested grids
            GridViewDataColumn column = new GridViewDataColumn();
            column.HeaderText = "Orders by customer";
            column.UniqueName = "CustomColumn";
            column.FieldName = "CusomerID";
            column.Width = 300;
            column.ReadOnly = true;
            this.radGridView1.Columns.Add(column);

            column = new GridViewDataColumn();
            column.HeaderText = "Orders by customer";
            column.UniqueName = "CustomColumn1";
            column.FieldName = "CusomerID";
            column.Width = 300;
            column.ReadOnly = true;
            this.radGridView1.Columns.Add(column);

            this.radGridView1.MasterGridViewTemplate.AutoGenerateColumns = false;            
        }        

        private void radGridView1_CreateCell(object sender, GridViewCreateCellEventArgs e)
        {
            if (e.Row is GridDataRowElement)
            {
                GridViewDataColumn dataCoulumn = e.Column as GridViewDataColumn;

                if (dataCoulumn != null && dataCoulumn.UniqueName.StartsWith("CustomColumn"))
                {
                    e.CellElement = new NestedComboCellElement(this, e.Column, e.Row);
                }
            }
        }

        public object GetBindingSource(object currentRow, object keyValue)
        {
            NwindDataSet.CustomersRow customer = (NwindDataSet.CustomersRow)((DataRowView)currentRow).Row;
            return new BindingList<NwindDataSet.OrdersRow>(customer.GetOrdersRows());
        }
    }
}
